package ink.wgink.module.activiti.service.oa;

import ink.wgink.module.activiti.pojo.dtos.oa.NodeFieldDTO;
import ink.wgink.module.activiti.pojo.vos.oa.NodeFieldUpdateVO;

import java.util.List;

/**
 * @Description: 表单字段与流程节点
 * @Author: WenG
 * @Date: 2022/3/17 20:08
 * @Version: 1.0
 **/
public interface INodeFieldService {

    /**
     * 新增绑定
     *
     * @param nodeFieldUpdateVO
     */
    void save(NodeFieldUpdateVO nodeFieldUpdateVO);

    /**
     * 更新显示状态
     *
     * @param nodeFieldId
     * @param isVisible
     */
    void updateVisible(String nodeFieldId, Integer isVisible);

    /**
     * 更新编辑状态
     *
     * @param nodeFieldId
     * @param isEditable
     */
    void updateEditable(String nodeFieldId, Integer isEditable);

    /**
     * 节点列表
     *
     * @param deploymentId
     * @return
     */
    List<NodeFieldDTO> listNodeByDeploymentId(String deploymentId);

    /**
     * 节点字段列表
     *
     * @param deploymentId
     * @param flowNodeId
     * @return
     */
    List<NodeFieldDTO> listByDeploymentIdAndFlowNodeId(String deploymentId, String flowNodeId);

}
