layui.define(['jquery', 'upload', 'dialog', 'restajax', 'formUtils'], function(exports) {
    var $ = layui.jquery;
    var upload = layui.upload;
    var utils = layui.formUtils;
    var dialog = layui.dialog;
    var restAjax = layui.restajax;
    var formField = layui.formField;

    var viewerObj = {};

    var uploadImage = {
        /**
         * 根据json对象生成html对象
         * @param {object} json
         * @param {boolean} selected true 表示选择当前
         * */
        render: function (json, selected) {
            if (selected === undefined) {
                selected = false;
            }
            var _html = '<div id="{0}" class="layui-form-item layui-form-text {2}" data-id="{0}" data-tag="{1}" data-index="{3}">'.format(json.id, json.tag, selected ? 'active' : '', json.index);
            _html += '   <label class="layui-form-label layui-form-label-up">{0}</label>'.format(json.label);
            _html += '   <div class="layui-input-block layui-input-block-down">';
            _html += '       <input type="hidden" id="{0}File" name="{0}">'.format(json.id);;
            _html += '       <div class="layui-btn-container" id="{0}FileBox"></div>'.format(json.id);
            _html += '       <script id="{0}FileDownload" type="text/html">'.format(json.id);
            _html += '           {{# var fileName = \'{0}\'; }}'.format(json.id);
            _html += '           {{# if(d[fileName].length > 0) { }}';
            _html += '           {{#    var files = d[fileName];}}';
            _html += '           {{#    for(var i = 0, item = files[i]; item = files[i++];) { }}';
            _html += '               <div class="upload-image-box">';
            _html += '                   <span class="upload-image-span">';
            _html += '                       <img src="route/file/download/false/{{item.fileId}}" align="加载失败">';
            _html += '                   </span>';
            _html += '                   <a class="layui-btn layui-btn-xs layui-btn-danger text-danger {0}remove-image" href="javascript:void(0);" data-id="{{item.fileId}}" data-name="{{fileName}}">'.format(json.id);
            _html += '                       <i class="fa fa-trash-o"></i>';
            _html += '                   </a>';
            _html += '               </div>';
            _html += '           {{#    } }}';
            _html += '           {{# } }}';
            _html += '           {{# if(d[fileName].length < {0}) { }}'.format(json.count);
            _html += '               <div class="upload-image-box" style="width: auto; height: auto; padding: 5px;">';
            _html += '                   <a href="javascript:void(0);" id="{0}FileUpload" data-explain="{1}" data-name="{0}" style="display: block;">'.format(json.id, json.label);
            _html += '                       <i class="fa fa-plus-square-o" style="font-size: 70px;"></i>';
            _html += '                   </a>';
            _html += '               </div>';
            _html += '           {{# } }}';
            _html += '       </script>';
            _html += '   </div>';
            _html += '</div>';
            return _html;
        },
        update: function (json) {
            $('#'+ json.id +' .layui-form-label').text(json.label);
        },
        /* 获取对象 */
        jsonData: function (id, index, columncount) {
            //分配一个新的ID
            var _json = JSON.parse(JSON.stringify(formField.uploadImage));
            _json.id = id == undefined ? utils.guid() : id;
            _json.index = index;
            return _json;
        },
        /* 根据 json 对象显示对应的属性 */
        property: function (json) {
            $('#columnProperty').empty();
            var _html = '';
            _html = utils.renderCommonProperty(json); //获取通用属性HTML字符串
            //处理特殊字符串
            for (var key in json) {
                if (key === 'index') {
                    continue;
                }
            }
            $('#columnProperty').append(_html);
        },
        componentRender: function(item) {
            var files = $('#'+ item.id +'File').val();
            utils.initFileList(item.id, files, function(fileName) {
                var viewer = new Viewer(document.getElementById(fileName +'FileBox'), {navbar: false});
                viewerObj[fileName] = viewer;
            });

            function initUpload() {
                upload.render({
                    elem: '#' + item.id +'FileUpload',
                    url: restAjax.path(item.uploadUrl, []),
                    field: 'image',
                    done: function(res) {
                        var dataset = this.item[0].dataset;
                        var name = dataset.name;
                        var files = $('#'+ name).val();
                        if(files.length > 0) {
                            files += ',';
                        }
                        files += res.data;
                        utils.initFileList(name, files, function(fileName) {
                            viewerObj[fileName].update();
                        });
                    },
                    error: function() {
                        dialog.msg('图片上传异常')
                    }
                });
            }
            initUpload();

            $('.'+ item.id +'remove-image').on('click', function() {
                var name = this.dataset.name;
                var id = this.dataset.id;
                var files = $('#'+ name).val().replace(id, '');
                files = files.replace(/\,+/g, ',');
                if(files.charAt(0) == ',') {
                    files = files.substring(1);
                }
                if(files.charAt(files.length - 1) == ',') {
                    files = files.substring(0, files.length - 1);
                }
                utils.initFileList(name, files, function(fileName) {
                    viewerObj[fileName].update();
                    initUpload();
                });
            });
        },
        code: {
            html: [],
            script: {
                func: [],
                init: {
                    save: [],
                    update: []
                },
                submit: [],
            }
        }
    };

    exports('uploadImage', uploadImage);
});